<template>
  <div class="py-8 px-8">
    <h4 class="grey--text" style="margin-left: -10px">
      <v-btn icon class="mb-1" @click="$router.push('/')"
        ><v-icon>mdi-arrow-left</v-icon></v-btn
      >Back to Home
    </h4>
    <h1 class="mb-0">Favourites Photo</h1>
    <v-card elevation="5" class="mt-4">
      <v-card-text>
        <h2 v-if="datas_photo.length === 0" class="text-center my-5">
          No favorite photo
        </h2>
        <v-row v-else>
          <v-col
            v-for="(item, i) in datas_photo"
            :key="i"
            lg="3"
            md="3"
            sm="6"
            cols="12"
          >
            <div class="container-img">
              <v-btn icon class="favorite-icon" @click="removeFavourite(item)"
                ><v-icon large>mdi-close</v-icon></v-btn
              >
              <img
                :src="
                  item.url ||
                    'https://www.generationsforpeace.org/wp-content/uploads/2018/03/empty.jpg'
                "
                :alt="`image`"
                @click="openDialogPhoto(item)"
              />
              <div class="figcaption">{{ item.title }}</div>
            </div>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>

    <v-dialog v-model="dialog_photo" max-width="800">
      <v-card>
        <v-toolbar color="primary" dark
          >Detail Photo
          <v-btn text class="ml-auto" @click="dialog_photo = false"
            >Close</v-btn
          >
        </v-toolbar>
        <CommentDialog
          v-if="dialog_photo_item"
          :dialog-photo-item="dialog_photo_item"
        />
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import CommentDialog from "@/components/CommentDialog";
export default {
  layout: "Favourite",
  components: {
    CommentDialog
  },
  data() {
    return {
      datas_photo: [],
      dialog_photo: false,
      dialog_photo_item: null
    };
  },
  watch: {
    dialog_photo(val) {
      if (!val) {
        this.dialog_photo_item = null;
      }
    }
  },
  created() {
    this.load();
  },
  methods: {
    load() {
      if (process.client) {
        this.datas_photo =
          JSON.parse(localStorage.getItem("favourites-photo")) || [];
      }
    },
    removeFavourite(item) {
      if (this.checkFavouriteExist(item) === 1) {
        this.$store.dispatch("removeFavourite", item);
        this.load();
      }
    },
    checkFavouriteExist(item) {
      const is_exist = JSON.parse(localStorage.getItem("favourites-photo"))
        ? JSON.parse(localStorage["favourites-photo"]).filter(
            obj => obj.id === item.id && obj.albumId === item.albumId
          ).length
        : 0;
      return is_exist;
    },
    openDialogPhoto(item) {
      this.dialog_photo = true;
      this.dialog_photo_item = item;
    }
  }
};
</script>

<style lang="scss" scoped>
.container-img {
  position: relative;
  img {
    max-width: 100%;
    display: block;
    cursor: pointer;
  }
  .favorite-icon {
    top: 10px;
    right: 10px;
    position: absolute;
  }

  .figcaption {
    position: absolute;
    bottom: 0;
    left: 0;
    background-color: rgba(255, 255, 255, 0.5);
    padding: 0.2em 0.5em;
    justify-self: start;
  }
}
</style>
